Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4268)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4270)
@@ -26,4 +26,15 @@
 ! -----------------
 ! $Id$
+! - Implement offline nesting for salsa
+! - Alphabetic ordering for module interfaces
+! - Remove init_aerosol_type and init_gases_type from salsa_parin and define them
+!   based on the initializing_actions
+! - parameter definition removed from "season" and "season_z01" is added to parin
+! - bugfix in application of index_hh after implementing the new
+!   palm_date_time_mod
+! - Reformat salsa emission data with LOD=2: size distribution given for each
+!   emission category
+! 
+! 4268 2019-10-17 11:29:38Z schwenkel
 ! Moving module specific boundary conditions from time_integration to module
 ! 
@@ -31,5 +42,5 @@
 ! Document previous changes: use global variables nx, ny and nz in salsa_header
 ! 
-! 4255 2019-10-04 11:50:55Z monakurppa
+! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
 ! 
@@ -241,11 +252,8 @@
                                                    !< 1 = H2SO4, 2 = HNO3, 3 = NH3, 4 = OCNV
                                                    !< (non-volatile OC), 5 = OCSV (semi-volatile)
-    INTEGER(iwp), PARAMETER ::  nmod = 7     !< number of modes for initialising the aerosol size
-                                             !< distribution
+    INTEGER(iwp), PARAMETER ::  nmod = 7     !< number of modes for initialising the aerosol size distribution
     INTEGER(iwp), PARAMETER ::  nreg = 2     !< Number of main size subranges
     INTEGER(iwp), PARAMETER ::  maxspec = 7  !< Max. number of aerosol species
-    INTEGER(iwp), PARAMETER ::  season = 1   !< For dry depostion by Zhang et al.: 1 = summer,
-                                             !< 2 = autumn (no harvest yet), 3 = late autumn
-                                             !< (already frost), 4 = winter, 5 = transitional spring
+
 
     REAL(wp), PARAMETER ::  fill_value = -9999.0_wp    !< value for the _FillValue attribute
@@ -253,22 +261,16 @@
 !-- Universal constants
     REAL(wp), PARAMETER ::  abo    = 1.380662E-23_wp   !< Boltzmann constant (J/K)
-    REAL(wp), PARAMETER ::  alv    = 2.260E+6_wp       !< latent heat for H2O
-                                                       !< vaporisation (J/kg)
+    REAL(wp), PARAMETER ::  alv    = 2.260E+6_wp       !< latent heat for H2O vaporisation (J/kg)
     REAL(wp), PARAMETER ::  alv_d_rv  = 4896.96865_wp  !< alv / rv
-    REAL(wp), PARAMETER ::  am_airmol = 4.8096E-26_wp  !< Average mass of one air
-                                                       !< molecule (Jacobson,
-                                                       !< 2005, Eq. 2.3)
+    REAL(wp), PARAMETER ::  am_airmol = 4.8096E-26_wp  !< Average mass of an air molecule (Jacobson 2005, Eq.2.3)
     REAL(wp), PARAMETER ::  api6   = 0.5235988_wp      !< pi / 6
     REAL(wp), PARAMETER ::  argas  = 8.314409_wp       !< Gas constant (J/(mol K))
     REAL(wp), PARAMETER ::  argas_d_cpd = 8.281283865E-3_wp  !< argas per cpd
     REAL(wp), PARAMETER ::  avo    = 6.02214E+23_wp    !< Avogadro constant (1/mol)
-    REAL(wp), PARAMETER ::  d_sa   = 5.539376964394570E-10_wp  !< diameter of condensing sulphuric
-                                                               !< acid molecule (m)
+    REAL(wp), PARAMETER ::  d_sa   = 5.539376964394570E-10_wp  !< diameter of condensing H2SO4 molecule (m)
     REAL(wp), PARAMETER ::  for_ppm_to_nconc =  7.243016311E+16_wp !< ppm * avo / R (K/(Pa*m3))
-    REAL(wp), PARAMETER ::  epsoc  = 0.15_wp          !< water uptake of organic
-                                                      !< material
+    REAL(wp), PARAMETER ::  epsoc  = 0.15_wp          !< water uptake of organic material
     REAL(wp), PARAMETER ::  mclim  = 1.0E-23_wp       !< mass concentration min limit (kg/m3)
-    REAL(wp), PARAMETER ::  n3     = 158.79_wp        !< Number of H2SO4 molecules in 3 nm cluster
-                                                      !< if d_sa=5.54e-10m
+    REAL(wp), PARAMETER ::  n3     = 158.79_wp        !< Number of H2SO4 molecules in 3 nm cluster if d_sa=5.54e-10m
     REAL(wp), PARAMETER ::  nclim  = 1.0_wp           !< number concentration min limit (#/m3)
     REAL(wp), PARAMETER ::  surfw0 = 0.073_wp         !< surface tension of water at 293 K (J/m2)
@@ -377,5 +379,4 @@
     INTEGER(iwp) ::  depo_pcm_type_num = 0  !< index for the dry deposition type on the plant canopy
     INTEGER(iwp) ::  depo_surf_par_num = 1  !< parametrisation type: 1=zhang2001, 2=petroff2010
-    INTEGER(iwp) ::  dots_salsa = 0         !< starting index for salsa-timeseries
     INTEGER(iwp) ::  end_subrange_1a = 1    !< last index for bin subrange 1a
     INTEGER(iwp) ::  end_subrange_2a = 1    !< last index for bin subrange 2a
@@ -392,12 +393,11 @@
     INTEGER(iwp) ::  init_aerosol_type = 0  !< Initial size distribution type
                                             !< 0 = uniform (read from PARIN)
-                                            !< 1 = read vertical profile of the mode number
-                                            !<     concentration from an input file
+                                            !< 1 = read vertical profiles from an input file
     INTEGER(iwp) ::  init_gases_type = 0    !< Initial gas concentration type
                                             !< 0 = uniform (read from PARIN)
-                                            !< 1 = read vertical profile from an input file
+                                            !< 1 = read vertical profiles from an input file
     INTEGER(iwp) ::  lod_gas_emissions = 0  !< level of detail of the gaseous emission data
-    INTEGER(iwp) ::  main_street_id = 0     !< lower bound of main street IDs (OpenStreetMaps) for parameterized mode
-    INTEGER(iwp) ::  max_street_id = 0      !< upper bound of main street IDs (OpenStreetMaps) for parameterized mode
+    INTEGER(iwp) ::  main_street_id = 0     !< lower bound of main street IDs for parameterized emission mode
+    INTEGER(iwp) ::  max_street_id = 0      !< upper bound of main street IDs for parameterized emission mode
     INTEGER(iwp) ::  nbins_aerosol = 1      !< total number of size bins
     INTEGER(iwp) ::  ncc   = 1              !< number of chemical components used
@@ -422,5 +422,8 @@
                                             !<     + heteromolecular nucleation with H2SO4*ORG
     INTEGER(iwp) ::  salsa_pr_count = 0     !< counter for salsa variable profiles
-    INTEGER(iwp) ::  side_street_id = 0     !< lower bound of side street IDs (OpenStreetMaps) for parameterized mode
+    INTEGER(iwp) ::  season_z01 = 1         !< For dry deposition by Zhang et al.: 1 = summer,
+                                            !< 2 = autumn (no harvest yet), 3 = late autumn
+                                            !< (already frost), 4 = winter, 5 = transitional spring
+    INTEGER(iwp) ::  side_street_id = 0     !< lower bound of side street IDs for parameterized emission mode
     INTEGER(iwp) ::  start_subrange_1a = 1  !< start index for bin subranges: subrange 1a
     INTEGER(iwp) ::  start_subrange_2a = 1  !<                                subrange 2a
@@ -448,10 +451,9 @@
     LOGICAL ::  feedback_to_palm        = .FALSE.  !< Allow feedback due to condensation of H2O
     LOGICAL ::  nest_salsa              = .FALSE.  !< Apply nesting for salsa
+    LOGICAL ::  nesting_offline_salsa   = .FALSE.  !< Apply offline nesting for salsa
     LOGICAL ::  no_insoluble            = .FALSE.  !< Exclude insoluble chemical components
     LOGICAL ::  read_restart_data_salsa = .FALSE.  !< Read restart data for salsa
-    LOGICAL ::  salsa_gases_from_chem   = .FALSE.  !< Transfer the gaseous components to SALSA from
-                                                   !< the chemistry model
-    LOGICAL ::  van_der_waals_coagc     = .FALSE.  !< Enhancement of coagulation kernel by van der
-                                                   !< Waals and viscous forces
+    LOGICAL ::  salsa_gases_from_chem   = .FALSE.  !< Transfer the gaseous components to SALSA
+    LOGICAL ::  van_der_waals_coagc     = .FALSE.  !< Include van der Waals and viscous forces in coagulation
     LOGICAL ::  write_binary_salsa      = .FALSE.  !< read binary for salsa
 !
@@ -491,4 +493,5 @@
     REAL(wp) ::  ocsv_init = nclim                   !< Init value for semi-volatile organic gases
     REAL(wp) ::  rhlim = 1.20_wp                     !< RH limit in %/100. Prevents unrealistical RH
+    REAL(wp) ::  time_utc_init                       !< time in seconds-of-day of origin_date_time
     REAL(wp) ::  skip_time_do_salsa = 0.0_wp         !< Starting time of SALSA (s)
 !
@@ -503,9 +506,9 @@
 !
 !-- Initial mass fractions / chemical composition of the size distribution
-    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_a = & !< mass fractions between
-             (/1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for A bins
-    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_b = & !< mass fractions between
-             (/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/) !< aerosol species for B bins
-    REAL(wp), DIMENSION(nreg+1) ::  reglim = & !< Min&max diameters of size subranges
+    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_a = &  !< mass fractions between
+             (/1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/)     !< aerosol species for A bins
+    REAL(wp), DIMENSION(maxspec) ::  mass_fracs_b = &  !< mass fractions between
+             (/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/)     !< aerosol species for B bins
+    REAL(wp), DIMENSION(nreg+1) ::  reglim = &         !< Min&max diameters of size subranges
                                  (/ 3.0E-9_wp, 5.0E-8_wp, 1.0E-5_wp/)
 !
@@ -628,12 +631,58 @@
        REAL(wp) ::  fill  !< fill value
 
-       REAL(wp), DIMENSION(:), ALLOCATABLE :: preproc_mass_fracs  !< mass fractions
-
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: def_mass_fracs  !< mass fractions per emis. category
-
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: def_data      !< surface emission values in PM
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: preproc_data  !< surface emission values per bin
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: mass_fracs  !< mass fractions per emis. category
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE :: num_fracs   !< number fractions per emis. category
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: def_data      !< surface emission in PM
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: preproc_data  !< surface emission per category
 
     END TYPE salsa_emission_value_type
+!
+!-- Offline nesting data type
+    TYPE salsa_nest_offl_type
+
+       CHARACTER(LEN=16) ::  char_l = 'ls_forcing_left_'  !< leading substring at left boundary
+       CHARACTER(LEN=17) ::  char_n = 'ls_forcing_north_' !< leading substring at north boundary
+       CHARACTER(LEN=17) ::  char_r = 'ls_forcing_right_' !< leading substring at right boundary
+       CHARACTER(LEN=17) ::  char_s = 'ls_forcing_south_' !< leading substring at south boundary
+       CHARACTER(LEN=15) ::  char_t = 'ls_forcing_top_'   !< leading substring at top boundary
+
+       CHARACTER(LEN=5), DIMENSION(1:ngases_salsa) ::  gas_name = (/'h2so4','hno3 ','nh3  ','ocnv ','ocsv '/)
+
+       CHARACTER(LEN=25),  DIMENSION(:), ALLOCATABLE ::  cc_name    !< chemical component name
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names  !< list of variable names
+
+       INTEGER(iwp) ::  id_dynamic  !< NetCDF id of dynamic input file
+       INTEGER(iwp) ::  ncc         !< number of aerosol chemical components
+       INTEGER(iwp) ::  nt          !< number of time levels in dynamic input file
+       INTEGER(iwp) ::  nzu         !< number of vertical levels on scalar grid in dynamic input file
+       INTEGER(iwp) ::  tind        !< time index for reference time in mesoscale-offline nesting
+       INTEGER(iwp) ::  tind_p      !< time index for following time in mesoscale-offline nesting
+
+       INTEGER(iwp), DIMENSION(maxspec) ::  cc_in2mod = 0  !< to transfer chemical composition from input to model
+
+       LOGICAL ::  init  = .FALSE. !< flag indicating the initialisation of offline nesting
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  dmid      !< vertical profile of aerosol bin diameters
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time      !< time in dynamic input file
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu_atmos  !< zu in dynamic input file
+
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  gconc_left   !< gas conc. at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  gconc_north  !< gas conc. at north boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  gconc_right  !< gas conc. at right boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  gconc_south  !< gas conc. at south boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  gconc_top    !< gas conc.at top boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mconc_left   !< aerosol mass conc. at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mconc_north  !< aerosol mass conc. at north boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mconc_right  !< aerosol mass conc. at right boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mconc_south  !< aerosol mass conc. at south boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  mconc_top    !< aerosol mass conc. at top boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  nconc_left   !< aerosol number conc. at left boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  nconc_north  !< aerosol number conc. at north boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  nconc_right  !< aerosol number conc. at right boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  nconc_south  !< aerosol number conc. at south boundary
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  nconc_top    !< aerosol number conc. at top boundary
+
+    END TYPE salsa_nest_offl_type
 !
 !-- Prognostic variable: Aerosol size bin information (number (#/m3) and mass (kg/m3) concentration)
@@ -728,4 +777,7 @@
                                     !< component name: 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
 !
+!-- Offline nesting:
+    TYPE(salsa_nest_offl_type) ::  salsa_nest_offl  !< data structure for offline nesting
+!
 !-- Data output arrays:
 !
@@ -808,8 +860,4 @@
     END INTERFACE salsa_define_netcdf_grid
 
-    INTERFACE salsa_driver
-       MODULE PROCEDURE salsa_driver
-    END INTERFACE salsa_driver
-
     INTERFACE salsa_emission_update
        MODULE PROCEDURE salsa_emission_update
@@ -831,4 +879,16 @@
        MODULE PROCEDURE salsa_init_arrays
     END INTERFACE salsa_init_arrays
+
+    INTERFACE salsa_nesting_offl_bc
+       MODULE PROCEDURE salsa_nesting_offl_bc
+    END INTERFACE salsa_nesting_offl_bc
+
+    INTERFACE salsa_nesting_offl_init
+       MODULE PROCEDURE salsa_nesting_offl_init
+    END INTERFACE salsa_nesting_offl_init
+
+    INTERFACE salsa_nesting_offl_input
+       MODULE PROCEDURE salsa_nesting_offl_input
+    END INTERFACE salsa_nesting_offl_input
 
     INTERFACE salsa_non_advective_processes
@@ -873,20 +933,56 @@
 !
 !-- Public functions:
-    PUBLIC salsa_boundary_conds, salsa_check_data_output, salsa_check_parameters, salsa_boundary_conditions, &
-           salsa_3d_data_averaging, salsa_data_output_2d, salsa_data_output_3d,                    &
-           salsa_data_output_mask, salsa_define_netcdf_grid, salsa_diagnostics, salsa_driver,      &
-           salsa_emission_update, salsa_header, salsa_init, salsa_init_arrays, salsa_parin,        &
-           salsa_rrd_local, salsa_swap_timelevel, salsa_prognostic_equations, salsa_wrd_local,     &
-           salsa_actions, salsa_non_advective_processes, salsa_exchange_horiz_bounds,              &
-           salsa_check_data_output_pr, salsa_statistics
+    PUBLIC salsa_3d_data_averaging,       &
+           salsa_actions,                 &
+           salsa_boundary_conds,          &
+           salsa_boundary_conditions,     &
+           salsa_check_data_output,       &
+           salsa_check_data_output_pr,    &
+           salsa_check_parameters,        &
+           salsa_data_output_2d,          &
+           salsa_data_output_3d,          &
+           salsa_data_output_mask,        &
+           salsa_define_netcdf_grid,      &
+           salsa_diagnostics,             &
+           salsa_emission_update,         &
+           salsa_exchange_horiz_bounds,   &
+           salsa_header,                  &
+           salsa_init,                    &
+           salsa_init_arrays,             &
+           salsa_nesting_offl_bc,         &
+           salsa_nesting_offl_init,       &
+           salsa_nesting_offl_input,      &
+           salsa_non_advective_processes, &
+           salsa_parin,                   &
+           salsa_prognostic_equations,    &
+           salsa_rrd_local,               &
+           salsa_statistics,              &
+           salsa_swap_timelevel,          &
+           salsa_wrd_local
+
 !
 !-- Public parameters, constants and initial values
-    PUBLIC bc_am_t_val, bc_an_t_val, bc_gt_t_val, dots_salsa, dt_salsa,                            &
-           ibc_salsa_b, last_salsa_time, lsdepo, nest_salsa, salsa, salsa_gases_from_chem,         &
+    PUBLIC bc_am_t_val,           &
+           bc_an_t_val,           &
+           bc_gt_t_val,           &
+           ibc_salsa_b,           &
+           init_aerosol_type,     &
+           init_gases_type,       &
+           nest_salsa,            &
+           nesting_offline_salsa, &
+           salsa_gases_from_chem, &
            skip_time_do_salsa
 !
-!-- Public prognostic variables
-    PUBLIC aerosol_mass, aerosol_number, gconc_2, mconc_2, nbins_aerosol, ncc, ncomponents_mass,   &
-           nclim, nconc_2, ngases_salsa, prtcl, ra_dry, salsa_gas, sedim_vd
+!-- Public variables
+    PUBLIC aerosol_mass,     &
+           aerosol_number,   &
+           gconc_2,          &
+           mconc_2,          &
+           nbins_aerosol,    &
+           ncomponents_mass, &
+           nconc_2,          &
+           ngases_salsa,     &
+           salsa_gas,        &
+           salsa_nest_offl
 
 
@@ -930,6 +1026,4 @@
                                      h2so4_init,                               &
                                      hno3_init,                                &
-                                     init_gases_type,                          &
-                                     init_aerosol_type,                        &
                                      listspec,                                 &
                                      main_street_id,                           &
@@ -940,4 +1034,5 @@
                                      nbin,                                     &
                                      nest_salsa,                               &
+                                     nesting_offline_salsa,                    &
                                      nf2a,                                     &
                                      nh3_init,                                 &
@@ -958,4 +1053,5 @@
                                      salsa,                                    &
                                      salsa_emission_mode,                      &
+                                     season_z01,                               &
                                      sigmag,                                   &
                                      side_street_id,                           &
@@ -1002,15 +1098,16 @@
 
     USE control_parameters,                                                                        &
-        ONLY:  humidity
+        ONLY:  humidity, initializing_actions
 
     IMPLICIT NONE
 
 !
-!-- Checks go here (cf. check_parameters.f90).
+!-- Check that humidity is switched on
     IF ( salsa  .AND.  .NOT.  humidity )  THEN
        WRITE( message_string, * ) 'salsa = ', salsa, ' is not allowed with humidity = ', humidity
        CALL message( 'salsa_check_parameters', 'PA0594', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
+!-- Set bottom boundary condition flag
     IF ( bc_salsa_b == 'dirichlet' )  THEN
        ibc_salsa_b = 0
@@ -1021,5 +1118,6 @@
        CALL message( 'salsa_check_parameters', 'PA0595', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
+!-- Set top boundary conditions flag
     IF ( bc_salsa_t == 'dirichlet' )  THEN
        ibc_salsa_t = 0
@@ -1032,16 +1130,32 @@
        CALL message( 'salsa_check_parameters', 'PA0596', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
+!-- If nest_salsa = .F., set top boundary to dirichlet
+    IF ( .NOT. nest_salsa  .AND.  ibc_salsa_t == 2  )  THEN
+       ibc_salsa_t = 0
+       bc_salsa_t = 'dirichlet'
+    ENDIF
+!
+!-- Check J3 parametrisation
     IF ( nj3 < 1  .OR.  nj3 > 3 )  THEN
        message_string = 'unknown nj3 (must be 1-3)'
        CALL message( 'salsa_check_parameters', 'PA0597', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
+!-- Check bottom boundary condition in case of surface emissions
     IF ( salsa_emission_mode /= 'no_emission'  .AND.  ibc_salsa_b  == 0 ) THEN
        message_string = 'salsa_emission_mode /= "no_emission" requires bc_salsa_b = "Neumann"'
        CALL message( 'salsa_check_parameters','PA0598', 1, 2, 0, 6, 0 )
     ENDIF
-
+!
+!-- Check whether emissions are applied
     IF ( salsa_emission_mode /= 'no_emission' )  include_emission = .TRUE.
+!
+!-- Set the initialisation type: background concentration are read from PIDS_DYNAMIC if
+!-- initializing_actions = 'inifor set_constant_profiles'
+    IF ( INDEX( initializing_actions, 'inifor' ) /= 0 )  THEN
+       init_aerosol_type = 1
+       init_gases_type = 1
+    ENDIF
 
  END SUBROUTINE salsa_check_parameters
@@ -3751,5 +3865,5 @@
        alpha   = alpha_z01(depo_pcm_type_num)
        gamma   = gamma_z01(depo_pcm_type_num)
-       par_a   = A_z01(depo_pcm_type_num, season) * 1.0E-3_wp
+       par_a   = A_z01(depo_pcm_type_num, season_z01) * 1.0E-3_wp
 !
 !--    Deposition efficiencies from Table 1. Constants from Table 2.
@@ -3992,5 +4106,5 @@
     alpha   = alpha_z01(luc_urban)
     gamma   = gamma_z01(luc_urban)
-    par_a   = A_z01(luc_urban, season) * 1.0E-3_wp
+    par_a   = A_z01(luc_urban, season_z01) * 1.0E-3_wp
 
     par_l            = l_p10(luc_urban) * 0.01_wp
@@ -4014,5 +4128,5 @@
              alpha = alpha_z01( match_array%match_lupg(m) )
              gamma = gamma_z01( match_array%match_lupg(m) )
-             par_a = A_z01( match_array%match_lupg(m), season ) * 1.0E-3_wp
+             par_a = A_z01( match_array%match_lupg(m), season_z01 ) * 1.0E-3_wp
 
              beta_im          = beta_im_p10( match_array%match_lupg(m) )
@@ -4045,5 +4159,5 @@
              alpha = alpha_z01( match_array%match_luvw(m) )
              gamma = gamma_z01( match_array%match_luvw(m) )
-             par_a = A_z01( match_array%match_luvw(m), season ) * 1.0E-3_wp
+             par_a = A_z01( match_array%match_luvw(m), season_z01 ) * 1.0E-3_wp
 
              beta_im          = beta_im_p10( match_array%match_luvw(m) )
@@ -4076,5 +4190,5 @@
              alpha = alpha_z01( match_array%match_luww(m) )
              gamma = gamma_z01( match_array%match_luww(m) )
-             par_a = A_z01( match_array%match_luww(m), season ) * 1.0E-3_wp
+             par_a = A_z01( match_array%match_luww(m), season_z01 ) * 1.0E-3_wp
 
              beta_im          = beta_im_p10( match_array%match_luww(m) )
@@ -8215,4 +8329,7 @@
  SUBROUTINE salsa_boundary_conds_decycle ( sq, sq_init )
 
+    USE control_parameters,                                                                        &
+        ONLY:  nesting_offline
+
     IMPLICIT NONE
 
@@ -8232,4 +8349,7 @@
 
     flag = 0.0_wp
+!
+!-- Skip input if forcing from larger-scale models is applied.
+    IF ( nesting_offline  .AND.  nesting_offline_salsa )  RETURN
 !
 !-- Left and right boundaries
@@ -8403,4 +8523,7 @@
  SUBROUTINE salsa_emission_update
 
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  get_date_time
+
     IMPLICIT NONE
 
@@ -8408,10 +8531,15 @@
 
        IF ( time_since_reference_point >= skip_time_do_salsa  )  THEN
-
-          IF ( next_aero_emission_update <= time_since_reference_point )  THEN
+!
+!--       Get time_utc_init from origin_date_time
+          CALL get_date_time( 0.0_wp, second_of_day = time_utc_init )
+
+          IF ( next_aero_emission_update <=                                                        &
+               MAX( time_since_reference_point, 0.0_wp ) + time_utc_init )  THEN
              CALL salsa_emission_setup( .FALSE. )
           ENDIF
 
-          IF ( next_gas_emission_update <= time_since_reference_point )  THEN
+          IF ( next_gas_emission_update <=                                                         &
+               MAX( time_since_reference_point, 0.0_wp ) + time_utc_init )  THEN
              IF ( salsa_emission_mode == 'read_from_file'  .AND.  .NOT. salsa_gases_from_chem )    &
              THEN
@@ -8474,5 +8602,11 @@
     LOGICAL, INTENT(in) ::  init  !< if .TRUE. --> initialisation call
 
-    REAL(wp) ::  second_of_day    !< second of the day
+    REAL(wp) ::  second_of_day  !< second of the day
+
+    REAL(wp), DIMENSION(24) ::  par_emis_time_factor =  & !< time factors for the parameterized mode
+                                                      (/ 0.009, 0.004, 0.004, 0.009, 0.029, 0.039, &
+                                                         0.056, 0.053, 0.051, 0.051, 0.052, 0.055, &
+                                                         0.059, 0.061, 0.064, 0.067, 0.069, 0.069, &
+                                                         0.049, 0.039, 0.039, 0.029, 0.024, 0.019 /)
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  nsect_emission  !< sectional number emission
@@ -8501,4 +8635,12 @@
                 ENDDO
              ELSE
+!
+!--             Get a time factor for the specific hour
+                IF ( .NOT.  ALLOCATED( aero_emission_att%time_factor ) )                           &
+                   ALLOCATE( aero_emission_att%time_factor(1) )
+                CALL get_date_time( MAX( time_since_reference_point, 0.0_wp ), hour=hour_of_day )
+                index_hh = hour_of_day
+                aero_emission_att%time_factor(1) = par_emis_time_factor(index_hh+1)
+
                 IF ( street_type_f%from_file )  THEN
                    DO  i = nxl, nxr
@@ -8506,8 +8648,10 @@
                          IF ( street_type_f%var(j,i) >= main_street_id  .AND.                      &
                               street_type_f%var(j,i) < max_street_id )  THEN
-                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_main
+                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_main *          &
+                                                  aero_emission_att%time_factor(1)
                          ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND.                  &
                                   street_type_f%var(j,i) < main_street_id )  THEN
-                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_side
+                            source_array(j,i,:) = nsect_emission(:) * emiss_factor_side *          &
+                                                  aero_emission_att%time_factor(1)
                          ENDIF
                       ENDDO
@@ -8587,6 +8731,5 @@
 !
 !--          Read the index and name of chemical components
-             CALL get_dimension_length( id_salsa, aero_emission_att%ncc,         &
-                                                          'composition_index' )
+             CALL get_dimension_length( id_salsa, aero_emission_att%ncc, 'composition_index' )
              ALLOCATE( aero_emission_att%cc_index(1:aero_emission_att%ncc) )
              CALL get_variable( id_salsa, 'composition_index', aero_emission_att%cc_index )
@@ -8629,4 +8772,42 @@
              ENDIF
 !
+!--          Get number of emission categories
+             CALL get_dimension_length( id_salsa, aero_emission_att%ncat, 'ncat' )
+!
+!--          Get the chemical composition (i.e. mass fraction of different species) in aerosols
+             IF ( check_existence( aero_emission_att%var_names, 'emission_mass_fracs' ) )  THEN
+                ALLOCATE( aero_emission%mass_fracs(1:aero_emission_att%ncat,                       &
+                                                   1:aero_emission_att%ncc) )
+                CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%mass_fracs,      &
+                                   0, aero_emission_att%ncc-1, 0, aero_emission_att%ncat-1 )
+             ELSE
+                message_string = 'Missing emission_mass_fracs in ' //  TRIM( input_file_salsa )
+                CALL message( 'salsa_emission_setup', 'PA0659', 1, 2, 0, 6, 0 )
+             ENDIF
+!
+!--          If the chemical component is not activated, set its mass fraction to 0 to avoid
+!--          inbalance between number and mass flux
+             cc_i2m = aero_emission_att%cc_in2mod
+             IF ( index_so4 < 0  .AND.  cc_i2m(1) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(1)) = 0.0_wp
+             IF ( index_oc  < 0  .AND.  cc_i2m(2) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(2)) = 0.0_wp
+             IF ( index_bc  < 0  .AND.  cc_i2m(3) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(3)) = 0.0_wp
+             IF ( index_du  < 0  .AND.  cc_i2m(4) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(4)) = 0.0_wp
+             IF ( index_ss  < 0  .AND.  cc_i2m(5) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(5)) = 0.0_wp
+             IF ( index_no  < 0  .AND.  cc_i2m(6) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(6)) = 0.0_wp
+             IF ( index_nh  < 0  .AND.  cc_i2m(7) > 0 )                                            &
+                aero_emission%mass_fracs(:,cc_i2m(7)) = 0.0_wp
+!
+!--          Then normalise the mass fraction so that SUM = 1
+             DO  in = 1, aero_emission_att%ncat
+                aero_emission%mass_fracs(in,:) = aero_emission%mass_fracs(in,:) /                  &
+                                                 SUM( aero_emission%mass_fracs(in,:) )
+             ENDDO
+!
 !--          Inquire the fill value
              CALL get_attribute( id_salsa, '_FillValue', aero_emission%fill, .FALSE.,              &
@@ -8659,6 +8840,5 @@
                 ENDIF
 !
-!--             Get number of emission categories and allocate emission arrays
-                CALL get_dimension_length( id_salsa, aero_emission_att%ncat, 'ncat' )
+!--             Allocate emission arrays
                 ALLOCATE( aero_emission_att%cat_index(1:aero_emission_att%ncat),                   &
                           aero_emission_att%rho(1:aero_emission_att%ncat),                         &
